Bug 2183595 - GDB 13.1 internal-error getting a backtrace from Rust
Summary: GDB 13.1 internal-error getting a backtrace from Rust
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: gdb
Version: 37
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Keith Seitz
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2023-03-31 18:04 UTC by Josh Stone
Modified: 2023-04-19 02:52 UTC (History)
9 users (show)

Fixed In Version: gdb-13.1-3.fc38 gdb-13.1-3.fc37
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2023-04-15 02:05:10 UTC
Type: Bug
Embargoed:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Sourceware 30158 0 P2 RESOLVED rustc testsuite fails with 13.1, apparently worked before with trunk 20230114 on i686-linux-gnu and powerpc64le-linux-gn... 2023-03-31 18:04:16 UTC

Description Josh Stone 2023-03-31 18:04:17 UTC
Description of problem:
GDB sometimes hits an internal-error while debugging Rust programs.

Version-Release number of selected component (if applicable):
gdb-13.1-1.fc37.x86_64
cargo-1.68.2-1.fc37.x86_64
rust-1.68.2-1.fc37.x86_64

How reproducible:
fully

Steps to Reproduce:
1. cargo new hello; cd hello
2. edit src/main.rs to the following:

fn main() {
    std::thread::scope(|s| {
        s.spawn(|| {
            println!("Hello, world!");
            std::process::abort();
        });
    });
}

3. cargo build
4. gdb -ex run -ex bt target/debug/hello

Actual results:

(gdb) bt
../../gdb/frame.c:2457: internal-error: inside_main_func: Assertion `block != nullptr' failed.
A problem internal to GDB has been detected,
further debugging may prove unreliable.

Expected results:
No internal-error :)

Additional info:
It works if I downgrade to gdb-12.1-4.fc37.x86_64

There is already an upstream fix queued for 13.2:
https://sourceware.org/bugzilla/show_bug.cgi?id=30158

Comment 1 Fedora Update System 2023-04-03 14:19:51 UTC
FEDORA-2023-9acb60a40e has been submitted as an update to Fedora 37. https://bodhi.fedoraproject.org/updates/FEDORA-2023-9acb60a40e

Comment 2 Fedora Update System 2023-04-03 14:20:36 UTC
FEDORA-2023-85e813d1ac has been submitted as an update to Fedora 38. https://bodhi.fedoraproject.org/updates/FEDORA-2023-85e813d1ac

Comment 3 Fedora Update System 2023-04-04 02:16:59 UTC
FEDORA-2023-85e813d1ac has been pushed to the Fedora 38 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-85e813d1ac

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 4 Fedora Update System 2023-04-04 02:37:43 UTC
FEDORA-2023-9acb60a40e has been pushed to the Fedora 37 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2023-9acb60a40e`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-9acb60a40e

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 5 Fedora Update System 2023-04-15 02:05:10 UTC
FEDORA-2023-85e813d1ac has been pushed to the Fedora 38 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 6 Fedora Update System 2023-04-19 02:52:50 UTC
FEDORA-2023-9acb60a40e has been pushed to the Fedora 37 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.